package com.lqkj.link.util;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.JsonDeserializer;
import com.fasterxml.jackson.databind.JsonNode;
import org.locationtech.jts.geom.Geometry;
import org.locationtech.jts.io.WKTReader;

import java.io.IOException;

public class GeometryDeserializer extends JsonDeserializer<Geometry> {

    private final WKTReader wktReader = new WKTReader();

    @Override
    public Geometry deserialize(JsonParser p, DeserializationContext context) throws IOException {
        JsonNode node = p.getCodec().readTree(p);
        String wkt = node.textValue();
        try {
            return wktReader.read(wkt);
        } catch (Exception e) {
            throw new IOException("Invalid geometry", e);
        }
    }
}